<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TIPregelGraphLibrary: src/standard/modules/engine/PregelCombiner.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TIPregelGraphLibrary
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search", false, 'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Groups</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_3a3fb334f8e32f8b75f30f6eb3cfdf6e.html">src</a></li><li class="navelem"><a class="el" href="dir_41b3ccb19a6d365afc2b4a7bbd034095.html">standard</a></li><li class="navelem"><a class="el" href="dir_e5e605185631aa34c675c5c984a4ce63.html">modules</a></li><li class="navelem"><a class="el" href="dir_3fa050c996938dec645331749b364588.html">engine</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">PregelCombiner.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="PregelCombiner_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;</div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#ifndef PREGELCOMBINER_HPP_</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#define PREGELCOMBINER_HPP_</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> ALG_MESSAGE_TYPE&gt;</div>
<div class="line"><a name="l00029"></a><span class="lineno"><a class="line" href="classPregelCombiner.html">   29</a></span>&#160;<span class="keyword">class </span><a class="code" href="classPregelCombiner.html">PregelCombiner</a></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;{</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> vector&lt;ALG_MESSAGE_TYPE&gt;::iterator MESSAGE_ITERATOR;</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    <span class="comment">//===========================================================================================</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <span class="comment">// constructor/destructor</span></div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <a class="code" href="classPregelCombiner.html">PregelCombiner</a>(){}</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <span class="keyword">virtual</span> ~<a class="code" href="classPregelCombiner.html">PregelCombiner</a>(){}</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <span class="comment">//===========================================================================================</span></div>
<div class="line"><a name="l00047"></a><span class="lineno"><a class="line" href="classPregelCombiner.html#aeca1f2c7da196d3831c1eee739cf291b">   47</a></span>&#160;<span class="comment"></span>    uint32 <a class="code" href="classPregelCombiner.html#aeca1f2c7da196d3831c1eee739cf291b">combineMessages</a>(MESSAGE_ITERATOR itIn, uint32 numMessages, MESSAGE_ITERATOR itOut)</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    {</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;        <span class="comment">// reduces the onverall number of messages for each node</span></div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;        <span class="comment">// returns the output number of messages</span></div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;        <span class="keywordflow">return</span> 0;</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    }</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="comment">//===========================================================================================</span></div>
<div class="line"><a name="l00060"></a><span class="lineno"><a class="line" href="classPregelCombiner.html#a0a504caf4a20b568bd3eaf4e390a1bf1">   60</a></span>&#160;<span class="comment"></span>    uint32 <a class="code" href="classPregelCombiner.html#a0a504caf4a20b568bd3eaf4e390a1bf1">sumCombineMessages</a>(MESSAGE_ITERATOR itIn, uint32 numMessages, MESSAGE_ITERATOR itOut)</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    {</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;         <span class="keywordflow">if</span>(numMessages == 0)</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;             <span class="keywordflow">return</span> 0;</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;         <span class="keywordflow">if</span>(itOut != itIn)</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;        {</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;            itOut-&gt;setMessage(*itIn);</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;        }</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;        <span class="keywordflow">if</span>(numMessages == 1)</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;            <span class="keywordflow">return</span> 1;</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;         itIn++;</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;         <span class="keywordflow">for</span>(uint32 loopCount = 1; loopCount &lt; numMessages;loopCount++)<span class="comment">//for(; itm !=  itIn-&gt;end(); ++itm)//</span></div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;         {</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;             itOut-&gt;sumContent(itIn-&gt;getContent());<span class="comment">//itStart-&gt;sumContent(itm-&gt;getContent());</span></div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;             ++itIn;</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;         }</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;         <span class="keywordflow">return</span> 1;</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    }</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    <span class="comment">//===========================================================================================</span></div>
<div class="line"><a name="l00088"></a><span class="lineno"><a class="line" href="classPregelCombiner.html#a1b1cd59b4b0e47d2e7793040f8fd6b64">   88</a></span>&#160;<span class="comment"></span>    uint32 <a class="code" href="classPregelCombiner.html#a1b1cd59b4b0e47d2e7793040f8fd6b64">maxCombineMessages</a>(MESSAGE_ITERATOR itIn, uint32 numMessages, MESSAGE_ITERATOR itOut)</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    {</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;         <span class="keywordflow">if</span>(numMessages == 0)</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;             <span class="keywordflow">return</span> 0;</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;         <span class="keywordflow">if</span>(itOut != itIn)</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;        {</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;            itOut-&gt;setMessage(*itIn);</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;        }</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;        <span class="keywordflow">if</span>(numMessages == 1)</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;            <span class="keywordflow">return</span> 1;</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;         itIn++;</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;         <span class="keywordflow">for</span>(uint32 loopCount = 1; loopCount &lt; numMessages;loopCount++)<span class="comment">//for(; itm !=  itIn-&gt;end(); ++itm)</span></div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;         {</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;             itOut-&gt;maxContent(*itIn);<span class="comment">//itStart-&gt;maxContent(*itm);</span></div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;             ++itIn;</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;         }</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;         <span class="keywordflow">return</span> 1;</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;    }</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;    <span class="comment">//===========================================================================================</span></div>
<div class="line"><a name="l00115"></a><span class="lineno"><a class="line" href="classPregelCombiner.html#a0d4e525d1d8f7180c34078b9b6217b81">  115</a></span>&#160;<span class="comment"></span>    uint32 <a class="code" href="classPregelCombiner.html#a0d4e525d1d8f7180c34078b9b6217b81">minCombineMessages</a>(MESSAGE_ITERATOR itIn, uint32 numMessages, MESSAGE_ITERATOR itOut)</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;    {</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;         <span class="keywordflow">if</span>(numMessages == 0)</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;             <span class="keywordflow">return</span> 0;</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;         <span class="keywordflow">if</span>(itOut != itIn)</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;        {</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;            itOut-&gt;setMessage(*itIn);</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;        }</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;        <span class="keywordflow">if</span>(numMessages == 1)</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;            <span class="keywordflow">return</span> 1;</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;         itIn++;</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;         <span class="keywordflow">for</span>(uint32 loopCount = 1; loopCount &lt; numMessages;loopCount++)<span class="comment">//for(; itm !=  itIn-&gt;end(); ++itm)</span></div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;         {</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;             itOut-&gt;minContent(*itIn);<span class="comment">//itStart-&gt;maxContent(*itm);</span></div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;             ++itIn;</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;         }</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;         <span class="keywordflow">return</span> 1;</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;    }</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;};</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* PREGELCOMBINER_HPP_ */</span><span class="preprocessor"></span></div>
<div class="ttc" id="classPregelCombiner_html_a0d4e525d1d8f7180c34078b9b6217b81"><div class="ttname"><a href="classPregelCombiner.html#a0d4e525d1d8f7180c34078b9b6217b81">PregelCombiner::minCombineMessages</a></div><div class="ttdeci">uint32 minCombineMessages(MESSAGE_ITERATOR itIn, uint32 numMessages, MESSAGE_ITERATOR itOut)</div><div class="ttdoc">implementation of minimum combine function. it computes the minimum the data fields of all messages i...</div><div class="ttdef"><b>Definition:</b> PregelCombiner.hpp:115</div></div>
<div class="ttc" id="classPregelCombiner_html_a1b1cd59b4b0e47d2e7793040f8fd6b64"><div class="ttname"><a href="classPregelCombiner.html#a1b1cd59b4b0e47d2e7793040f8fd6b64">PregelCombiner::maxCombineMessages</a></div><div class="ttdeci">uint32 maxCombineMessages(MESSAGE_ITERATOR itIn, uint32 numMessages, MESSAGE_ITERATOR itOut)</div><div class="ttdoc">implementation of maximum combine function. it computes the maximum the data fields of all messages i...</div><div class="ttdef"><b>Definition:</b> PregelCombiner.hpp:88</div></div>
<div class="ttc" id="classPregelCombiner_html"><div class="ttname"><a href="classPregelCombiner.html">PregelCombiner</a></div><div class="ttdef"><b>Definition:</b> PregelCombiner.hpp:29</div></div>
<div class="ttc" id="classPregelCombiner_html_aeca1f2c7da196d3831c1eee739cf291b"><div class="ttname"><a href="classPregelCombiner.html#aeca1f2c7da196d3831c1eee739cf291b">PregelCombiner::combineMessages</a></div><div class="ttdeci">uint32 combineMessages(MESSAGE_ITERATOR itIn, uint32 numMessages, MESSAGE_ITERATOR itOut)</div><div class="ttdoc">empty core combine function. Here it is an empty function that must be overridden by customized verte...</div><div class="ttdef"><b>Definition:</b> PregelCombiner.hpp:47</div></div>
<div class="ttc" id="classPregelCombiner_html_a0a504caf4a20b568bd3eaf4e390a1bf1"><div class="ttname"><a href="classPregelCombiner.html#a0a504caf4a20b568bd3eaf4e390a1bf1">PregelCombiner::sumCombineMessages</a></div><div class="ttdeci">uint32 sumCombineMessages(MESSAGE_ITERATOR itIn, uint32 numMessages, MESSAGE_ITERATOR itOut)</div><div class="ttdoc">implementation of sum combine function. it sums the data fields of all messages into a single message...</div><div class="ttdef"><b>Definition:</b> PregelCombiner.hpp:60</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Fri Oct 3 2014 16:46:36 for TIPregelGraphLibrary by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
